﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;


namespace DataGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            #region DataSource
            DataCollection dataSource = new DataCollection();
            Random rand = new Random();
            int r = rand.Next(100);
            for (int i = 0; i < 20; i++)
            {
                dataSource.Add(new Data(r.ToString(), "Category" + r.ToString(), "Desc" + r.ToString(), r.ToString() + "Data"));
                r = rand.Next(100);
            }
            this.gridGroupingControl1.DataSource = dataSource;
            #endregion          
        }

        private void moveBtn_Click(object sender, EventArgs e)
        {
            int columnIndex = -1;           
            int.TryParse(this.columnIndexText.Text.ToString(), out columnIndex);

            //Getting the record rowIndex based on its position
            int recordIndex = -1;           
            int.TryParse(this.recordIndexText.Text.ToString(), out recordIndex);

            if (recordIndex > 0 && columnIndex > 0)
            {
                //Getting RowIndex and ColumnIndex 
                columnIndex = this.gridGroupingControl1.TableDescriptor.FieldToColIndex(columnIndex - 1);
                recordIndex = this.gridGroupingControl1.Table.Records[recordIndex - 1].GetRowIndex();

                //Moving the current cell
                this.gridGroupingControl1.TableControl.CurrentCell.MoveTo(recordIndex, columnIndex, Syncfusion.Windows.Forms.Grid.GridSetCurrentCellOptions.SetFocus);
                this.gridGroupingControl1.Focus();

                //Setting the cursor at end position of cell
                if (this.gridGroupingControl1.TableControl.CurrentCell.Renderer is GridTextBoxCellRenderer)
                {
                    GridTextBoxCellRenderer renderer = this.gridGroupingControl1.TableControl.CurrentCell.Renderer as GridTextBoxCellRenderer;
                    renderer.TextBox.SelectionStart = renderer.TextBox.Text.Length;
                }
            }
        }

        private void moveWithHighlightBtn_Click(object sender, EventArgs e)
        {
            int columnIndex = -1;            
            int.TryParse(this.columnIndexText.Text.ToString(), out columnIndex);

            //Getting the record rowIndex based on its position
            int recordIndex = -1;            
            int.TryParse(this.recordIndexText.Text.ToString(), out recordIndex);

            if (recordIndex > 0 && columnIndex > 0)
            {
                //Getting RowIndex and ColumnIndex 
                columnIndex = this.gridGroupingControl1.TableDescriptor.FieldToColIndex(columnIndex - 1);
                recordIndex = this.gridGroupingControl1.Table.Records[recordIndex - 1].GetRowIndex();

                //Moving the current cell
                this.gridGroupingControl1.TableControl.CurrentCell.MoveTo(recordIndex, columnIndex, Syncfusion.Windows.Forms.Grid.GridSetCurrentCellOptions.SetFocus);
                this.gridGroupingControl1.Focus();

                //Setting the cursor at end position of cell
                if (this.gridGroupingControl1.TableControl.CurrentCell.Renderer is GridTextBoxCellRenderer)
                {
                    GridTextBoxCellRenderer renderer = this.gridGroupingControl1.TableControl.CurrentCell.Renderer as GridTextBoxCellRenderer;
                    renderer.TextBox.SelectAll();
                }
            }
        }        
    }
}
